routes/web.php
<?php

use App\Http\Controllers\AuthorController;
use App\Http\Controllers\BlogPostController;
use App\Http\Controllers\CommentController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\InternalAreaController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
     // return view('welcome');
     // return "GIPE 2022 - Let's start the endeavour and create a portal for the Colegio San Juan Apostol in Arequipa, Peru!";
     // return view('home.index',[]);
// })->name('home.index');
// Route::get('/contact', function () {
    // return "This is the contact page!";
    // return view('home.contact',[]);
// })->name('contact.index');
Route::get('/', [HomeController::class,'home'])->name('home.index');
Route::get('/contact', [HomeController::class,'contact'])->name('contact.index');
// $posts = [
//     1 => [
//         'title' => 'Intro to laravel',
//         'content' => 'This is a short intro to laravel',
//         'is_new' => true
//     ],
//     2 => [
//         'title' => 'Intro to PHP',
//         'content' => 'This is a short intro to PHP',
//         'is_new' => false
//     ],
// ];
// Route::get('/posts', function () use ($posts) {
//     // return "This is the posts page!";
//     return view('posts.index',['posts' => $posts]);
// })->name('posts.index');
// Route::get('/posts/{id}', function ($id) use ($posts) {
//     // return "Blog Post {$id}";
//     abort_if(!isset($posts[$id]), 404);
//     return view('posts.show', ['post' => $posts[$id]]);
// })->name('posts.show');
Route::get('/recent-posts/{days_ago?}', function ($days_ago = 20) {
    return "Posts from {$days_ago} days ago";
})->name('posts.recent.index');
Route::resource('blogposts',BlogPostController::class);
Route::resource('authors',AuthorController::class);
Route::resource('comments',CommentController::class)->only(['store','create']);
Route::get('/home', [InternalAreaController::class, 'home'])->name('home.index');
Auth::routes();

app/Models/Author.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Author extends Model
{
    use HasFactory;
    protected $fillable = ['authorName','authorEmail'];
    public function profile()
    { 
        return $this->hasOne(Profile::class);
    }
}

app/Http/Controllers/AuthorController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\StoreAuthor;
use App\Models\Author;
use App\Models\Profile;
use App\Notifications\AuthorCreated;
use Illuminate\Http\Request;

class AuthorController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function __construct()
    {
        $this->middleware('auth');
    }
    public function index()
    {
        return view('authors.index', ['authors' => Author::with('profile')->get()]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('authors.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(StoreAuthor $request)
    {
        $validated = $request->validated();
        $author = new Author();
        $profile = new Profile();
        $author->name = $validated['authorName'];
        $profile->email = $validated['authorEmail'];
        $author->save();
        $author->profile()->save($profile);

        $user = auth()->user();
        $user->prefers_sms = true;
        $channel = $user->prefers_sms ? 'SMS' : 'mail';
        $user->notify(new AuthorCreated($author));

        $request->session()->flash('status', 'New Author ' . $author->name . ' has been created and notification by ' . $channel . ' has been sent!');
        return redirect()->route('authors.show', ['author' => $author->id]);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        return view('authors.show', ['author' => Author::findOrFail($id)]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        return view('authors.update', ['author' => Author::findOrFail($id)]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $author = Author::findOrFail($id);
        $profile = Profile::Where('author_id', $id)->first();
        $validated = $request->validated();
        $author->fill($validated);
        $author->name = $validated['authorName'];
        $profile->email = $validated['email'];
        return redirect()->route('authors.show', ['author' => $author->id]);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $author = Author::findOrFail($id);
        $author->delete();
        session()->flash('status', 'The Author' . $author->name . 'was deleted!');
        return redirect()->route('authors.index');
    }
}

resources/views/authors/create.blade.php
@extends('layout.app')
@section('title', 'Create a new Author')
@section('content')
    <div>Create a new Author</div>
    <div class="mx-auto">
        <form action={{ route('authors.store') }} method="POST">
            @csrf
            @include('authors.partials.form')
            @php $text = "Create" @endphp {{-- indeed for demostration --}}
            <x-button class="primary" :text="$text">
        </form>
    </div>
@endsection

resources/views/authors/index.blade.php
@extends('layout.app')
@section('title', 'Authors page')
@section('content')
    <h1>Authors</h1>
    <table class="table table-stripped">
        <thead>
            <tr>
                <th scope="col">#</th>
                <th scope="col">Name</th>
                <th scope="col">Email</th>
            </tr>
        </thead>
        <tbody>
            @foreach ($authors as $key => $author)
                <tr>
                    <th scope="row">
                        {{ $key + 1 }}
                    </th>
                    <td>{{ $author['name'] }}</td>
                    <td>{{ $author['profile']['email'] }}</td>
                    <td>
                        <a href="{{ route('authors.show', ['author' => $author->id]) }}">
                            <button class="btn btn-primary">
                                View
                            </button>
                        </a>
                    </td>
                    <td>
                        <a href="{{ route('authors.edit', ['author' => $author->id]) }}">
                            <button class="btn btn-warning">
                                Edit
                            </button>
                        </a>
                    </td>
                    <td>
                        <form action="{{ route('authors.destroy', ['author' => $author->id]) }}" method="POST">
                            @csrf
                            @method('DELETE')
                            <button type="submit" class="btn btn-danger">
                                Delete
                            </button>
                        </form>
                </tr>
            @endforeach
        </tbody>
    </table>
@endsection

resources/views/authors/show.blade.php
@extends('layout.app')
@section('title', 'Author page')
@section('content')
    <h1>{{ $author['name'] }}</h1>
    <p>Email: {{ $author['profile']['email'] }}</p>
@endsection

resources/views/authors/update.blade.php
@extends('layout.app')
@section('title', 'Update Author')
@section('content')
    <h1>Update an existing Author</h1>
    <div class="mx-auto">
        <form action={{ route('authors.update', ['author' => $author->id]) }} method="POST">
            @csrf
            @method('PUT')
            @include('authors.partials.form')
            <button type="submit" class="btn btn-primary">Update</button>
        </form>
    </div>
@endsection